/*
   'I love you' sample program.
   Displays a window with 'I love you' in different languages

   Copyright 2005 Ilfak Guilfanov, <ig@hexblog.com>
   When copying the program you can not modify
   or delete the copyright message.
   Freeware.
*/

#include <windows.h>

static HWND th;
static wchar_t *full;
//---------------------------------------------------------------------------
#if 0   // this code was used to create love.cpp from love.txt
#include <stdio.h>
wchar_t mygetw(FILE *fp)
{
  int c1 = fgetc(fp);
  int c2 = fgetc(fp);
  if ( c1 == EOF && c2 == EOF )
    return EOF;
  return (c2 << 8) | c1;
}

static void prepare_love_txt(void)
{
  FILE *fp=fopen("love.txt","rb");
  FILE *out=fopen("love.cpp","w");
  mygetw(fp);
  static int idx = 0;
  int nsym = 0;
  while ( true )
  {
    wchar_t c = mygetw(fp);
    if ( c == wchar_t(EOF) ) break;
    if ( c == '\r' )
      continue;
    if ( nsym == 0 )
      fprintf(out, "static wchar_t x%d[] = { ", idx++);
    else
      fprintf(out, ", ");
    nsym++;
    if ( c == '\n' )
    {
      fprintf(out, " 0 };\n");
      nsym = 0;
      continue;
    }
    if ( char(c) == c && c >= ' ' && c != '\'' )
      fprintf(out, "'%c'", c);
    else
      fprintf(out, "0x%X", c);
  }
  fprintf(out, "\nstatic wchar_t *text[] = {");
  for ( int i=0; i < idx; i++ )
    fprintf(out, "x%d,", i);
  fprintf(out, "};\n");
  fclose(fp);
  fclose(out);
}
#else
#include "love.cpp"
#define qnumber(x) sizeof(x)/sizeof(x[0])

static const wchar_t header[] = L"I love you in many languages:";
static void prepare_love_txt(void)
{
  size_t size = 0;
  for ( int i=0; i < qnumber(text); i++ )
    size += wcslen(text[i]) + 2;
  full = new wchar_t[size+sizeof(header)];
  wchar_t *ptr = full;
  wcscpy(ptr, header);
  ptr += qnumber(header)-1;
  for ( int i=0; i < qnumber(text); i++ )
  {
    *ptr++ = '\r';
    *ptr++ = '\n';
    wcscpy(ptr, text[i]);
    ptr += wcslen(ptr);
  }
}
#endif

//---------------------------------------------------------------------------
LRESULT CALLBACK WndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
  RECT r;
  switch ( iMsg )
  {
    case WM_SIZE:
      GetClientRect(hwnd, &r);
      SetWindowPos(th, HWND_TOP, 0, 0, r.right, r.bottom,
       SWP_NOOWNERZORDER|SWP_DEFERERASE|SWP_NOMOVE|SWP_NOREDRAW|SWP_NOACTIVATE);
      break;
    case WM_ERASEBKGND:
      return 1;
    case WM_DESTROY:
      PostQuitMessage(0);
      return 0;
  }
  return DefWindowProc(hwnd, iMsg, wParam, lParam);
}

//---------------------------------------------------------------------------
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/,
		   LPSTR /*szCmdLine*/, int iCmdShow)
{
  static char szAppName[] = "loveyou";
  HWND        hwnd;
  MSG         msg;
  WNDCLASSEX  wndclass;

  /*  Fill in WNDCLASSEX struct members  */

  wndclass.cbSize         = sizeof(wndclass);
  wndclass.style          = CS_HREDRAW | CS_VREDRAW;
  wndclass.lpfnWndProc    = WndProc;
  wndclass.cbClsExtra     = 0;
  wndclass.cbWndExtra     = 0;
  wndclass.hInstance      = hInstance;
  wndclass.hIcon          = LoadIcon(NULL, IDI_APPLICATION);
  wndclass.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);
  wndclass.hCursor        = LoadCursor(NULL, IDC_ARROW);
  wndclass.hbrBackground  = (HBRUSH) GetStockObject(WHITE_BRUSH);
  wndclass.lpszClassName  = szAppName;
  wndclass.lpszMenuName   = NULL;


  /*  Register a new window class with Windows  */

  RegisterClassEx(&wndclass);


  /*  Create a window based on our new class  */

  hwnd = CreateWindow(szAppName, "I Love You",
			WS_OVERLAPPEDWINDOW,
			CW_USEDEFAULT, CW_USEDEFAULT,
			300, 600,
			NULL, NULL, hInstance, NULL);
//  SetClassLongPtr(hwnd, GCL_HBRBACKGROUND, (LONG)GetStockObject(LTGRAY_BRUSH));

  prepare_love_txt();

  RECT r;
  GetClientRect(hwnd, &r);
  th = CreateWindowW(L"EDIT", full,
			WS_CHILD|WS_VISIBLE|ES_MULTILINE|ES_READONLY|ES_LEFT,
			0, 0,
			r.right, r.bottom,
			hwnd, NULL, NULL, NULL);

  /*  Show and update our window  */

  ShowWindow(hwnd, iCmdShow);
  UpdateWindow(hwnd);

  /*  Retrieve and process messages until we get WM_QUIT  */

  while ( GetMessage(&msg, NULL, 0, 0) )
  {
	TranslateMessage(&msg);    /*  for certain keyboard messages  */
	DispatchMessage(&msg);     /*  send message to WndProc        */
  }

  /*  Exit with status specified in WM_QUIT message  */
  return msg.wParam;
}

